pro collect_weber_stack, filename, loops=loops, delay_time=delay_time, shutter=shutter

ystage = obj_new('epics_motor', '13BMD:m115')

file_PV     = '13BMDPG1:TS:FileName' 
acquire_PV  = '13BMDPG1:TS:StartScan'
shutter_PV  = '13BMD:Unidig2Bo10'

if (n_elements(loops) eq 0) then loops = 1
if (n_elements(delay_time) eq 0) then delay_time=0

for loop=0, loops-1 do begin
  if (keyword_set(shutter)) then begin
    t = caput(shutter_pv, 1)
    wait, 1
  endif
  file = filename + '_' + string(loop, format='(I3.3)')
  print, 'Collecting dataset ' + file
  t = caput(file_PV, [byte(file),0], /wait)
  wait, 1.0
  t = caput(file_PV, [byte(file),0], /wait)
  wait, 1.0
  status = caput(acquire_PV, 1)
  repeat begin
    wait, .1
    status = caget(acquire_PV, busy)
  endrep until (not busy)
  if (keyword_set(shutter)) then t = caput(shutter_pv, 0)
  if ((loop lt loops-1) and (delay_time ne 0)) then begin
    print, 'Waiting for ', delay_time, ' seconds'
    wait, delay_time
  endif
endfor

end

